/***
	Copyright (c) 2008-2009 CommonsWare, LLC
	
	Licensed under the Apache License, Version 2.0 (the "License"); you may
	not use this file except in compliance with the License. You may obtain
	a copy of the License at
		http://www.apache.org/licenses/LICENSE-2.0
	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

package com.commonsware.android.notify;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.TranslateAnimation;
import android.widget.Button;
import android.widget.TextView;
import android.widget.ViewFlipper;



import java.util.Timer;
import java.util.TimerTask;



public class NotifyDemo extends Activity {
	public static final int NOTIFY_ME_ID=1337;
	private Timer timer=new Timer();
	private int count=0;
	public int inc=0;
	TextView txt;
	public String[] cits={ "Aimer ce n'est pas renoncer  sa libert, c'est lui donner un sens. Marc Levy",
"L'amour est une force sauvage. Quand nous essayons de le contrler, il nous dtruit. Quand nous essayons de l'emprisonner, il nous rend esclaves. Quand nous essayons de le comprendre, il nous laisse perdus et confus. Paulo Coelho", 
"Lorsqu'une porte se ferme, il y en a une qui s'ouvre. Malheureusement, nous perdons tellement de temps  contempler la porte ferme, que nous ne voyons pas celle qui vient de s'ouvrir. Proverbes et maximes", 
"On n'est jamais heureux que dans le bonheur qu'on donne. Donner, c'est recevoir. Abb Pierre",
"Au sein de cet environnement instable et turbulent, un seul lment reste constant: le changement.",
"Celui qui dplace une montagne commence par dplacer de petites pierres. Confucius", 
"Suivez les trois R : Respect de soi-mme, Respect des autres, Responsabilit de tous vos actes. Dala Lama",
"Pour raliser une chose vraiment extraordinaire, commencez par la rver. Ensuite, rveillez-vous calmement et allez d'un trait jusqu'au bout de votre rve sans jamais vous laisser dcourager. C'est la seule mthode que je connaisse et elle m'a toujours russi. Walt Disney" 
}; 
	ViewFlipper vf;	
	
	private Animation inFromRightAnimation() {

		Animation inFromRight = new TranslateAnimation(
		Animation.RELATIVE_TO_PARENT,  +1.0f, Animation.RELATIVE_TO_PARENT,  0.0f,
		Animation.RELATIVE_TO_PARENT,  0.0f, Animation.RELATIVE_TO_PARENT,   0.0f
		);
		inFromRight.setDuration(500);
		inFromRight.setInterpolator(new AccelerateInterpolator());
		return inFromRight;
		}
		private Animation outToLeftAnimation() {
		Animation outtoLeft = new TranslateAnimation(
		  Animation.RELATIVE_TO_PARENT,  0.0f, Animation.RELATIVE_TO_PARENT,  -1.0f,
		  Animation.RELATIVE_TO_PARENT,  0.0f, Animation.RELATIVE_TO_PARENT,   0.0f
		);
		outtoLeft.setDuration(500);
		outtoLeft.setInterpolator(new AccelerateInterpolator());
		return outtoLeft;
		}

		private Animation inFromLeftAnimation() {
		Animation inFromLeft = new TranslateAnimation(
		Animation.RELATIVE_TO_PARENT,  -1.0f, Animation.RELATIVE_TO_PARENT,  0.0f,
		Animation.RELATIVE_TO_PARENT,  0.0f, Animation.RELATIVE_TO_PARENT,   0.0f
		);
		inFromLeft.setDuration(500);
		inFromLeft.setInterpolator(new AccelerateInterpolator());
		return inFromLeft;
		}
		private Animation outToRightAnimation() {
		Animation outtoRight = new TranslateAnimation(
		  Animation.RELATIVE_TO_PARENT,  0.0f, Animation.RELATIVE_TO_PARENT,  +1.0f,
		  Animation.RELATIVE_TO_PARENT,  0.0f, Animation.RELATIVE_TO_PARENT,   0.0f
		);
		outtoRight.setDuration(500);
		outtoRight.setInterpolator(new AccelerateInterpolator());
		return outtoRight;
		}

	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
						
		setContentView(R.layout.main);
		
		txt=(TextView)findViewById(R.id.text0);
		txt.setText(cits[0]);
		
		vf = (ViewFlipper) findViewById(R.id.vf);
		
		
		int i=0;
		
		for(i=1;i<cits.length;i++)
		{
			
			TextView txt= new TextView(this);
			txt.setText(cits[i]);
			
			vf.addView(txt, new ViewGroup.LayoutParams(
			ViewGroup.LayoutParams.FILL_PARENT,
			ViewGroup.LayoutParams.FILL_PARENT));	
					
		}
			
			
		final AlertDialog.Builder builder = new AlertDialog.Builder(this);
		
		
		
		Button next=(Button)findViewById(R.id.next);
	
		
		
		next.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
			
			ViewFlipper vf2 = (ViewFlipper) findViewById(R.id.vf); 
		    
            vf2.setInAnimation(inFromRightAnimation());
            vf2.setOutAnimation(outToLeftAnimation());
        	vf2.showNext();
        	//if (inc!=cits.length) inc++;
			
			 
			}			
			
			});
		
        Button prev=(Button)findViewById(R.id.prev);
		
		prev.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
		
			ViewFlipper vf2 = (ViewFlipper) findViewById(R.id.vf); 
			
			vf2.setInAnimation(inFromLeftAnimation());
	        vf2.setOutAnimation(outToRightAnimation());
			vf2.showPrevious();
			//if (inc!=0) inc--;
			
			
			}			
			
			});
		
		
		Button btn=(Button)findViewById(R.id.notify);
		
		btn.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
				TimerTask task=new TimerTask() {
					public void run() {
				
						vf = (ViewFlipper) findViewById(R.id.vf);
						TextView txt=(TextView)vf.getCurrentView();
						String t=(String) txt.getText();
						notifyMe(t);
																		
					}
				};
		
				timer.schedule(task, 1000);
				
				vf = (ViewFlipper) findViewById(R.id.vf);
				TextView txt=(TextView)vf.getCurrentView();
				String t=(String) txt.getText();
										
				builder.setMessage(t)
			       .setCancelable(false)
			       .setNegativeButton("Ok", new DialogInterface.OnClickListener() {
			           public void onClick(DialogInterface dialog, int id) {
			                dialog.cancel();
			           }
			       });
				AlertDialog alert = builder.create();
							
				alert.show();
				
			}
		});
		
		btn=(Button)findViewById(R.id.cancel);
		
		btn.setOnClickListener(new View.OnClickListener() {
			public void onClick(View view) {
				NotificationManager mgr=
					(NotificationManager)getSystemService(NOTIFICATION_SERVICE);
					
				mgr.cancel(NOTIFY_ME_ID);
			}
		});
	}
	
	private void notifyMe(String txt) {
		final NotificationManager mgr=
			(NotificationManager)getSystemService(NOTIFICATION_SERVICE);
		Notification note=new Notification(R.drawable.red_ball,
																"Citation",
																				System.currentTimeMillis());
		
		
		Intent intent = new Intent( this, NotifyMessage.class );
		
		if(intent.hasExtra("cit")) { intent.removeExtra("cit"); }
		intent.putExtra("cit",txt);		
		
		PendingIntent i=PendingIntent.getActivity(this, 0,intent,PendingIntent.FLAG_UPDATE_CURRENT);
		
		
		
		note.setLatestEventInfo(this, "Citation "+String.valueOf(inc) ,
														"Citation", i);
		note.number=++count;
		
		mgr.notify(NOTIFY_ME_ID, note);
		
		
	}

	public String getCitation() {
		
	return cits[inc];	
		
		
		
		
	}


}


